

#define Version "30/10/2015"
#define MyDemoBoard
/*
 * Project name:
     Counter
 * Copyright:
     (c) Mikroelektronika, 2010.
 * Description:
     This code demonstrates working with max7219 on Serial 7-seg Display2 board.
     Eight 7 segment displays are connected to MAX7219.
 * Test configuration:
     mcu:              ac:Datasheet_16F887
     
     Dev.Board:        ac:Board_Schema

     Oscillator:      internal FOSC    8.0 MHz
     ext. modules:
     
            ac:Max7219_datasheet
            
           ac:Afficheur_8_Max7219
           
            ac:Max7219_codage_7segm

     SW:
     Notes:      MSSP SPI mode     ac:SPI_config
 */
// Hardware :
// PICKIT2 pour alimenter la carte
// carte Microchip PICkit2 44 pin demo board avec PIC16F887
// 8 leds sur PORTD
// switch sur RB0

//Afficheur 8 digits MAX7219 et  SPI MCU:
//GRN = 0 Volt
//VCC = +5 Volts
//SI  = DIN (Data In , entre donne)   ---<---  RC5
//SO  = Serial Out (Not uesd)           --->---- RC4
//CS = DATA (validation dudes donnees)  ---<---- RC0
//SCL = CLK (horloge validation bit data)--<---_ RC3

//  UART1
//     RC6 -->--RXD HC06  ou  --> fil Vert  -- Prolix PL2303
//     RC7 --<--TXD HC06  ou  <-- fil Blanc -- Prolix PL2303

/*
******************************************************
* LED Segments:         a
*                     ----
*                   f|    |b
*                    |  g |
*                     ----
*                   e|    |c
*                    |    |
*                     ----  o dp
*                       d
*   Register bits:
*      bit:  7  6  5  4  3  2  1  0
*           dp  a  b  c  d  e  f  g
******************************************************
*/


#define POWER_SUPPLY_5V
#define FOSC_INTERNE 8  // MHz
#define BAUD 19200  // UART1


  //-- commandes terminal VT220
#define CLS 12     // effacement de page sur Terminal VBRAY
#define CR 13
#define VT 10
#define LF 10
#define TAB 9
#define Bell 7
#define Byte unsigned char

#define REG_DECODE        0x09                        // "decode mode" register
#define REG_INTENSITY     0x0A                        // "intensity" register
#define REG_SCAN_LIMIT    0x0B                        // "scan limit" register
#define REG_SHUTDOWN      0x0C                        // "shutdown" register
#define REG_DISPLAY_TEST  0x0F                        // "display test" register

#define INTENSITY_MIN     0x00                        // minimum display intensity
#define INTENSITY_MAX     0x0F                        // maximum display intensity



const char chaine0[]=" 16F887 test Afficheur 8 digits MAX7219 \r\n";
const char chaine1[]=" En en mode SPI hardware  use RC3,RC4,RC5,RC0 \r\n";
const char chaine2[]=" Oscillateur interne 8Mhz  Port PC XP COM12 19200 \r\n";

const char *RS_Str[]={chaine0,chaine1,chaine2};


//  pinout settings
sbit LD7 at RD7_bit;
sbit LD6 at RD6_bit;
sbit LD5 at RD5_bit;
sbit LD4 at RD4_bit;
sbit LD3 at RD3_bit;
sbit LD2 at RD2_bit;
sbit LD1 at RD1_bit;
sbit LD0 at RD0_bit;

sbit SW1 at RB0_bit;

// potar RP1 sur RA0 as EA0

// MAX7219 select
sbit Chip_Select at RC0_bit;
sbit Chip_Select_Direction at TRISC0_bit;

static const struct {
	char   ascii;
	char   segs;
} MAX7219_Font[] = {
  {' ', 0x00},
  {'0', 0x7e},
  {'1', 0x30},
  {'2', 0x6d},
  {'3', 0x79},
  {'4', 0x33},
  {'5', 0x5b},
  {'6', 0x5f},
  {'7', 0x70},
  {'8', 0x7f},
  {'9', 0x7b},
  {'A', 0x77},
  {'B', 0x1f},
  {'C', 0x4e},
  {'D', 0x3d},
  {'E', 0x4f},
  {'F', 0x47},
  {'\0', 0x00}
};


#define MAXLEN 31
unsigned char buffer[MAXLEN+1];
unsigned int Index1,i1;
unsigned int UART1_DataReady;
char c1;

char TEXTE[64];
char *txt;
char CRam1[17];
unsigned int  i,j,k;
unsigned int  M0;
unsigned long Freq;
float f1;

void interrupt(void)   // a chaque interruption sur rbo/int calcul debut et fin de periode
{
//UART1
   if((RCIF_bit==1) && (RCIE_bit==1))
   {
     c1 = RCREG;
     if(OERR_bit)
     {
        CREN_bit = 0;
        CREN_bit = 1;
        OERR_bit = 0;
     }
     if(FERR_bit)   c1 = RCREG;

     if ((c1==CR)|| (i1>=MAXLEN))
      {
        UART1_DataReady=1;
        if (i1 >= MAXLEN )  UART1_DataReady=2;
        //interdit IT Reception UART
        RCIE_bit=0;
        buffer[i1]=0;
        Index1=i1;
        i1=0;
        c1=0;
     }
     else
     {
       buffer[i1]=c1;
       Index1=i1;
       i1++;
      }
   }
 }

void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CRLF()
{
  UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

void RAZ_Uart()
{
for (i1=0;i1<MAXLEN;i1++) buffer[i1]=0;
i1=0;
Index1=0;
c1=0;
UART1_DataReady=0;
RCIE_bit=1;
}

void MAX7219_Mode_BCD(void)
{
  Chip_Select = 0;       // SELECT MAX
  SPI1_Write(0x09);      //
 SPI1_Write(0xFF);       // Code BCD decode for digits 70
  Chip_Select = 1;       // DESELECT MAX
}

void MAX7219_Mode_7seg(void)
{
  Chip_Select = 0;       // SELECT MAX
  SPI1_Write(0x09);
 SPI1_Write(0x00);       // No decode for digits 70
  Chip_Select = 1;       // DESELECT MAX
}


void MAX7219_Init1() 
{
  
   MAX7219_Mode_BCD();

  Chip_Select = 0;
  SPI1_Write(0x0A);     // Segment luminosity
  SPI1_Write(0x01);    // intensity = 3/32
 //  SPI1_Write(0x03);    // intensity = 7/32
//  SPI1_Write(0x07);    // intensity = 15/32
// SPI1_Write(0x0F);     // intensity = 32/32
  Chip_Select = 1;

  Chip_Select = 0;
 SPI1_Write(0x0B);
 SPI1_Write(0x07);      // Display refresh all digits  0 1 2 3 4 5 6 7
  Chip_Select = 1;

  Chip_Select = 0;
 SPI1_Write(0x0C);
 SPI1_Write(0x01);      // Turn on the display
  Chip_Select = 1;

  Chip_Select = 0;
 SPI1_Write(0x00);
 SPI1_Write(0xFF);      // No test
  Chip_Select = 1;
}


void  Affiche_ON (void)
{
     Chip_Select = 0;   // SELECT MAX
 SPI1_Write(0x0C);
 SPI1_Write(0x01);      // Turn on the display
  Chip_Select = 1;      // DESELECT MAX
   Delay_ms(500);
   }

void  Affiche_OFF (void)
{
     Chip_Select = 0;   // SELECT MAX
 SPI1_Write(0x0C);
 SPI1_Write(0x00);      // Turn offthe display
  Chip_Select = 1;      // DESELECT MAX
   Delay_ms(500);
   }
   

void Efface_Affichage(void)
{
int i;
for (i=1;i<=8;i++)
  {
    Chip_Select = 0;     // select max7219
   SPI1_Write(9-i);      // send i to max7219 (digit place)
   SPI1_Write(0x0F);
    Chip_Select = 1;     // deselect max7219
    Delay_ms(20);
  }
}


void affiche_Long(unsigned long L)
{char T[11];
  MAX7219_Mode_BCD();
 if(L<=99999999)
 {
 LongWordToStr(L,T) ;
for (i=1;i<=8;i++)
  {
    Chip_Select = 0;     // select max7219
   SPI1_Write(9-i);       // send i to max7219 (digit place)
   if(isdigit(*(T+i+1)))
    SPI1_Write(*(T+i+1)-48);
     else  SPI1_Write(0x0F);
    Chip_Select = 1;     // deselect max7219
    if (i>7) break;  // 8 digit maxi
    }
  }
 }
 void Affiche_HELP()
 {
  Chip_Select = 0;     // select max7219
   SPI1_Write(7);       // position du digit
   SPI1_Write(10);     // valeur du digit '-'
    Chip_Select = 1;
   Chip_Select = 0;     // select max7219
   SPI1_Write(6);       // position du digit
   SPI1_Write(12);     // valeur du digit 'H'
    Chip_Select = 1;
     Chip_Select = 0;
   SPI1_Write(5);       // position du digit
   SPI1_Write(11);     // valeur du digit 'E'
      Chip_Select = 1;
    Chip_Select = 0;
   SPI1_Write(4);       // position du digit
   SPI1_Write(13);     // valeur du digit 'L'
      Chip_Select = 1;
    Chip_Select = 0;
   SPI1_Write(3);       // position du digit
   SPI1_Write(14);     // valeur du digit 'L'
   Chip_Select = 1;
    Chip_Select = 0;     // select max7219
   SPI1_Write(2);       // position du digit
   SPI1_Write(10);     // valeur du digit '-'
    Chip_Select = 1;
   }
 
unsigned char MAX7219_LookupCode (char character)
{
// Description: Convert an alphanumeric character to the corresponding 7-segment code.
// Parametre : character to display
// Returns    : codage segments   or Zero
  int i;
  for (i = 0; MAX7219_Font[i].ascii; i++)      // scan font table for ascii code
    if (character == MAX7219_Font[i].ascii) 
      return MAX7219_Font[i].segs;            // return segments code
  return 0;                                   // if code not found, return null (blank)
}

static void MAX7219_Write (unsigned char reg_number, unsigned char dataout)
{

   Chip_Select = 0;       // select max7219
   SPI1_Write(reg_number);// position du digit
   SPI1_Write(dataout);   // valeur du digit
    Chip_Select = 1;
}

   
void MAX7219_DisplayChar (char digit, char character)
{
 // Display a character on the specified digit.
 // Parameter : digit = digit number (0-7)
 //              character = character to display (0-9, A-Z)
 //  Returns    : none
 
  MAX7219_Write(digit, MAX7219_LookupCode(character));
}

void MAX7219_Luminosite_Maxi(void)
{
  Chip_Select = 0;
   SPI1_Write(0x0A);     // Segment luminosity
   SPI1_Write(0xFF);    // intensity = 31/32
   Chip_Select = 1;
 }

void MAX7219_Luminosite_Mini(void)
{
  Chip_Select = 0;
   SPI1_Write(0x0A);     // Segment luminosity
   SPI1_Write(0x01);    // intensity = 3/32
   Chip_Select = 1;
 }
   
 
 void main(void)
{
      //Oscillateur_Interne car pas de Quartz !
       OSCCON=0b01110001 ; // 8MHz (111) & SCS=1  (sinon 4 MHz par defaut)
       Delay_ms(1000);
       TRISC=0x80;     // car RC7 =entree UART !
       TRISC4_bit=1;   // SDI
       TRISD=0;
       TRISB.B0=1; // rbo en entree su microcontrolleur
       TRISA.B0=1; // RA0 analog input

       ANSEL = 0x01;
       ANSELH = 0;
       PORTD=0;
       PORTC=0;

       txt=&TEXTE[0];
       Freq = Clock_kHz();
       LongWordToStr(Freq, txt) ;
       UART1_Init(19200);  // Q=20Mhz

    txt=&TEXTE[0];    // init pointeur
    c1 = RCREG;
    UART1_Write(CLS);  // efface ecran terminal VBRAY
    Delay_ms(1000);
    CRLF();
    // presentation
    UART1_Write_CText(RS_Str[0]);

    LongWordToStr(Freq, CRam1);
    UART1_Write_CText(" Freq FOSC= ");
    UART1_Write_Text(CRam1);
    CRLF();
    UART1_Write_CText(" Start Version : "Version"\r\n");
       
       

  Chip_Select_Direction = 0;    // Set RC0 pin as output
  UART1_Init(19200);
  txt=&TEXTE[0];
  UART1_Write_CText("Init MSSP en mode SPI1 RC3,RC4,RC5 et RC0 utiliss\r\n");
  // Initialize SPI1 module
  //SPI1 module is initialized on the RC3, RC4, RC5 pins (SCK, SDI, SDO, respectively).
  SPI1_Init();
  UART1_Write_CText("Init Module Afficheur 8 digits 7 segment MAX7219  \r\n");
  MAX7219_Init1(); // initialize  max7219 en mode B BCD
  
  k=strlen(txt);
  do
  {
   MAX7219_Mode_BCD();
  
   Efface_Affichage();

  Chip_Select = 0;
  SPI1_Write(0x0A);     // Segment luminosity
  SPI1_Write(0x07);    // intensity = 15/32
  Chip_Select = 1;

  Freq = Clock_kHz();
   affiche_Long(Freq);
   Freq=1; affiche_Long(Freq);  Delay_ms(2000);
   Freq=65535;  affiche_Long(Freq); Delay_ms(2000);
   Freq=99999999; affiche_Long(Freq); Delay_ms(2000);
   Freq=12345678;  affiche_Long(Freq);  Delay_ms(2000);
   
   for (i=0;i<10;i++)
   {
   MAX7219_Luminosite_Mini();
   Delay_ms(500);
    MAX7219_Luminosite_Maxi();
    Delay_ms(500);
   }
   
   Delay_ms(1000);
   for (i = 1; i<=8; i++) {
    Chip_Select = 0;     // select max7219
   SPI1_Write(i);       // position du digit
   SPI1_Write(9-i);     // valeur du digit en BCD
    Chip_Select = 1;     // deselect max7219
  }
   Affiche_OFF ();
   Delay_ms(300);
   Affiche_ON ();
   Delay_ms(300);
   Affiche_OFF ();
   Delay_ms(300);
   Affiche_ON ();
   Delay_ms(500);
  
   MAX7219_Luminosite_Mini();
   Efface_Affichage(); Affiche_HELP(); Delay_ms(1000);
   MAX7219_Luminosite_Maxi();
   Efface_Affichage(); Affiche_HELP(); Delay_ms(1000);
   MAX7219_Luminosite_Mini();
   Efface_Affichage(); Affiche_HELP(); Delay_ms(1000);
   MAX7219_Luminosite_Maxi();
   Delay_ms(1000);
   Efface_Affichage();
  
   MAX7219_Mode_7seg();
   MAX7219_DisplayChar (8,'A');
    MAX7219_DisplayChar (7,'B');
     MAX7219_DisplayChar (6,'C');
      MAX7219_DisplayChar (5,'D');
       MAX7219_DisplayChar (4,'E');
        MAX7219_DisplayChar (3,'F');
         MAX7219_DisplayChar (2,'9');
          MAX7219_DisplayChar (1,'8');
  Delay_ms(2000);
   
  }
 while(1);
}