#line 1 "C:/_MikroC/_MesProjets_MikroC/_16F887_MAX7219-digits/16F887_Max7219_Afficheur_8digits_SPI_160616.c"
#line 87 "C:/_MikroC/_MesProjets_MikroC/_16F887_MAX7219-digits/16F887_Max7219_Afficheur_8digits_SPI_160616.c"
const char chaine0[]=" 16F887 test Afficheur 8 digits MAX7219 \r\n";
const char chaine1[]=" En en mode SPI hardware  use RC3,RC4,RC5,RC0 \r\n";
const char chaine2[]=" Oscillateur interne 8Mhz  Port PC XP COM12 19200 \r\n";

const char *RS_Str[]={chaine0,chaine1,chaine2};



sbit LD7 at RD7_bit;
sbit LD6 at RD6_bit;
sbit LD5 at RD5_bit;
sbit LD4 at RD4_bit;
sbit LD3 at RD3_bit;
sbit LD2 at RD2_bit;
sbit LD1 at RD1_bit;
sbit LD0 at RD0_bit;

sbit SW1 at RB0_bit;




sbit Chip_Select at RC0_bit;
sbit Chip_Select_Direction at TRISC0_bit;


static const struct {
 char ascii;
 char segs;
} MAX7219_Font[] =
{
 {' ', 0},
 {'0', 126},
 {'1', 48},
 {'2', 109},
 {'3', 121},
 {'4', 51},
 {'5', 91},
 {'6', 95},
 {'7', 112},
 {'8', 127},
 {'9', 123},
 {'A', 119},
 {'B', 31},
 {'C', 13},
 {'D', 61},
 {'E', 79},
 {'F', 71},
 {'G', 123},
 {'H', 23},
 {'I', 6},
 {'J', 60},
 {'K', 55},
 {'L', 14},
 {'M', 118},
 {'N', 21},
 {'O', 29},
 {'P', 103},
 {'Q', 115},
 {'R', 102},
 {'S', 91},
 {'T', 15},
 {'U', 28},
 {'V', 62},
 {'W', 190},
 {'X', 183},
 {'Y', 59},
 {'Z', 237},
 {'.', 128},
 {'-', 1},
 {'+', 49},
 {'=', 9},
 {'\0', 0x00}
};




unsigned char buffer[ 31 +1];
unsigned int Index1,i1;
unsigned int UART1_DataReady;
char c1;

char TEXTE[64];
char *txt;
char CRam1[17];
unsigned int i,j,k;
unsigned int M0;
unsigned long Freq;
float f1;

char Mode;

void strConstRamCpy(unsigned char *dest, const code char *source);
void CRLF(void);
void UART1_Write_CText(const char *txt);
void RAZ_Uart(void);

void MAX7219_Init(void);
void MAX7219_Mode_BCD(void);
void MAX7219_Mode_7seg(void);
void MAX7219_Affiche_ON (void);
void MAX7219_Affiche_OFF (void) ;
void MAX7219_Efface(void);
void MAX7219_Affiche_Long(unsigned long L);
void MAX7219_Affiche_HELP();
unsigned char MAX7219_LookupCode (char cx);
void MAX7219_Write (unsigned char reg_number, unsigned char dataout);
void MAX7219_DisplayChar (char digit, char character) ;
void MAX7219_Luminosite_Maxi(void);
void MAX7219_Luminosite_Mini(void);
void MAX7219_Display_Text(char * T);
void MAX7219_Luminosite(int Lu);


void interrupt(void)
{

 if((RCIF_bit==1) && (RCIE_bit==1))
 {
 c1 = RCREG;
 if(OERR_bit)
 {
 CREN_bit = 0;
 CREN_bit = 1;
 OERR_bit = 0;
 }
 if(FERR_bit) c1 = RCREG;

 if ((c1== 13 )|| (i1>= 31 ))
 {
 UART1_DataReady=1;
 if (i1 >=  31  ) UART1_DataReady=2;

 RCIE_bit=0;
 buffer[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 else
 {
 buffer[i1]=c1;
 Index1=i1;
 i1++;
 }
 }
 }

void strConstRamCpy(unsigned char *dest, const code char *source)
 {
 while (*source)*dest++ = *source++ ;
 *dest = 0 ;
}

void CRLF()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
}

void UART1_Write_CText(const char *txt)
 {
 while (*txt)
 UART1_Write(*txt++);
}

void RAZ_Uart()
{
for (i1=0;i1< 31 ;i1++) buffer[i1]=0;
i1=0;
Index1=0;
c1=0;
UART1_DataReady=0;
RCIE_bit=1;
}

void MAX7219_Mode_BCD(void)
{
 Chip_Select = 0;
 SPI1_Write(0x09);
 SPI1_Write(0xFF);
 Chip_Select = 1;
 Mode=0;
}

void MAX7219_Mode_7seg(void)
{
 Chip_Select = 0;
 SPI1_Write(0x09);
 SPI1_Write(0x00);
 Chip_Select = 1;
 Mode=1;
}

void MAX7219_Init()
{
 Mode=0;
 MAX7219_Mode_BCD();
 Chip_Select = 0;
 SPI1_Write(0x0A);
 SPI1_Write(0x07);



 Chip_Select = 1;

 Chip_Select = 0;
 SPI1_Write(0x0B);
 SPI1_Write(0x07);
 Chip_Select = 1;

 Chip_Select = 0;
 SPI1_Write(0x0C);
 SPI1_Write(0x01);
 Chip_Select = 1;

 Chip_Select = 0;
 SPI1_Write(0x00);
 SPI1_Write(0xFF);
 Chip_Select = 1;
}

void MAX7219_Affiche_ON (void)
{
 Chip_Select = 0;
 SPI1_Write(0x0C);
 SPI1_Write(0x01);
 Chip_Select = 1;
 Delay_ms(50);
 }


void MAX7219_Affiche_OFF (void)
{
 Chip_Select = 0;
 SPI1_Write(0x0C);
 SPI1_Write(0x00);
 Chip_Select = 1;
 Delay_ms(50);
 }


void MAX7219_Efface(void)
{
int i;
for (i=1;i<=8;i++)
 {
 Chip_Select = 0;
 SPI1_Write(9-i);
 if(Mode==0)
 SPI1_Write(0x0F);
 else
 SPI1_Write(0);
 Chip_Select = 1;
 Delay_ms(20);
 }
}


void MAX7219_Affiche_Long(unsigned long L)
{char T[11];
 MAX7219_Mode_BCD();
 if(L<=99999999)
 {
 LongWordToStr(L,T) ;
for (i=1;i<=8;i++)
 {
 Chip_Select = 0;
 SPI1_Write(9-i);
 if(isdigit(*(T+i+1)))
 SPI1_Write(*(T+i+1)-48);
 else SPI1_Write(0x0F);
 Chip_Select = 1;
 if (i>7) break;
 }
 }
 }
 void MAX7219_Affiche_HELP()
 {

 MAX7219_Write (7,10);
#line 375 "C:/_MikroC/_MesProjets_MikroC/_16F887_MAX7219-digits/16F887_Max7219_Afficheur_8digits_SPI_160616.c"
 MAX7219_Write (6,12);
#line 382 "C:/_MikroC/_MesProjets_MikroC/_16F887_MAX7219-digits/16F887_Max7219_Afficheur_8digits_SPI_160616.c"
 MAX7219_Write (5,11);
#line 389 "C:/_MikroC/_MesProjets_MikroC/_16F887_MAX7219-digits/16F887_Max7219_Afficheur_8digits_SPI_160616.c"
 Chip_Select = 0;
 SPI1_Write(4);
 SPI1_Write(13);
 Chip_Select = 1;

 Chip_Select = 0;
 SPI1_Write(3);
 SPI1_Write(14);
 Chip_Select = 1;

 Chip_Select = 0;
 SPI1_Write(2);
 SPI1_Write(10);
 Chip_Select = 1;
 }

unsigned char MAX7219_LookupCode (char cx)
{



 int i;
 for (i = 0; MAX7219_Font[i].ascii; i++)
 if (cx == MAX7219_Font[i].ascii)
 return MAX7219_Font[i].segs;
 return 0;
 }

void MAX7219_Write (unsigned char reg_number, unsigned char dataout)
{
 Chip_Select = 0;
 SPI1_Write(reg_number);
 SPI1_Write(dataout);
 Chip_Select = 1;
}

void MAX7219_DisplayChar (char digit, char character)
{




 MAX7219_Write(digit, MAX7219_LookupCode(character));
}

void MAX7219_Luminosite_Maxi(void)
{
 Chip_Select = 0;
 SPI1_Write(0x0A);
 SPI1_Write(0xFF);
 Chip_Select = 1;
 }

void MAX7219_Luminosite_Mini(void)
{
 Chip_Select = 0;
 SPI1_Write(0x0A);
 SPI1_Write(0x01);
 Chip_Select = 1;
 }

 void MAX7219_Luminosite(int Lu)
 {
 switch(Lu)
 {
 case 0: { MAX7219_Write(0x0A,0x01); break;}
 case 1: { MAX7219_Write(0x0A,0x03); break;}
 case 2: { MAX7219_Write(0x0A,0x07); break;}
 case 3: { MAX7219_Write(0x0A,0x0F); break;}
 default :{ MAX7219_Write(0x0A,0x03); break;}
 }
 }



void MAX7219_Display_Text(char * T)
{
 int i,k;
 char c=32;
 k=strlen(T);
 if (k>8) k=8;
 for(i=k;i<8;i++) *(T+i)=0;
 for (i=1;i<=8;i++)
 {
 MAX7219_DisplayChar(9-i,*(T+i-1));
 Delay_ms(10);
 }
#line 484 "C:/_MikroC/_MesProjets_MikroC/_16F887_MAX7219-digits/16F887_Max7219_Afficheur_8digits_SPI_160616.c"
}


 void main(void)
{

 OSCCON=0b01110001 ;
 Delay_ms(1000);
 TRISC=0x80;
 TRISC4_bit=1;
 TRISD=0;
 TRISB.B0=1;
 TRISA.B0=1;

 ANSEL = 0x01;
 ANSELH = 0;
 PORTD=0;
 PORTC=0;

 txt=&TEXTE[0];
 Freq = Clock_kHz();
 LongWordToStr(Freq, txt) ;
 UART1_Init(19200);

 txt=&TEXTE[0];
 c1 = RCREG;
 UART1_Write( 12 );
 Delay_ms(1000);
 CRLF();

 UART1_Write_CText(RS_Str[0]);

 LongWordToStr(Freq, CRam1);
 UART1_Write_CText(" Freq FOSC= ");
 UART1_Write_Text(CRam1);
 CRLF();
 UART1_Write_CText(" Start Version : " "16/06/2016" "\r\n");



 Chip_Select_Direction = 0;
 UART1_Init(19200);
 txt=&TEXTE[0];
 UART1_Write_CText("Init MSSP en mode SPI1 RC3,RC4,RC5 et RC0 utiliss\r\n");


 SPI1_Init();
 UART1_Write_CText("Init Module Afficheur 8 digits 7 segment MAX7219  \r\n");
 MAX7219_Init();

 k=strlen(txt);
 Mode=0;

 do
 {
 MAX7219_Mode_BCD();

 MAX7219_Efface();

 Freq = Clock_kHz();
 MAX7219_Affiche_Long(Freq); Delay_ms(2000);
 Freq=1; MAX7219_Affiche_Long(Freq); Delay_ms(2000);
 Freq=65535; MAX7219_Affiche_Long(Freq); Delay_ms(2000);
 Freq=99999999; MAX7219_Affiche_Long(Freq); Delay_ms(2000);
 Freq=12345678; MAX7219_Affiche_Long(Freq); Delay_ms(2000);

 for (i=0;i<3;i++)
 {
 MAX7219_Luminosite(i);
 Delay_ms(1500);
 }
#line 567 "C:/_MikroC/_MesProjets_MikroC/_16F887_MAX7219-digits/16F887_Max7219_Afficheur_8digits_SPI_160616.c"
 MAX7219_Affiche_OFF ();
 Delay_ms(300);
 MAX7219_Affiche_ON ();
 Delay_ms(300);
 MAX7219_Affiche_OFF ();
 Delay_ms(300);
 MAX7219_Affiche_ON ();
 Delay_ms(300);

 MAX7219_Efface();
 MAX7219_Affiche_HELP();
 Delay_ms(500);
 for (i=0;i<3;i++)
 {
 MAX7219_Luminosite(i);
 Delay_ms(500);
 }

 MAX7219_Mode_7seg();

 MAX7219_DisplayChar (8,'A');
 MAX7219_DisplayChar (7,'B');
 MAX7219_DisplayChar (6,'C');
 MAX7219_DisplayChar (5,'D');
 MAX7219_DisplayChar (4,'E');
 MAX7219_DisplayChar (3,'F');
 MAX7219_DisplayChar (2,'9');
 MAX7219_DisplayChar (1,'8');
 Delay_ms(2000);


 MAX7219_Efface();
 MAX7219_Mode_7seg();
 strConstRamCpy(txt,"BONJOUR");
 MAX7219_Display_Text(txt);
 Delay_ms(3000);
 MAX7219_Efface();
 strConstRamCpy(txt,"SALUT");
 MAX7219_Display_Text(txt);
 Delay_ms(3000);
 strConstRamCpy(txt,"AMIGO 97");
 MAX7219_Display_Text(txt);
 Delay_ms(3000);
 strConstRamCpy(txt," B+A=BA ");
 MAX7219_Display_Text(txt);
 Delay_ms(3000);
 strConstRamCpy(txt,"12+48=60");
 MAX7219_Display_Text(txt);
 Delay_ms(3000);
 strConstRamCpy(txt,"1D286FEH");
 MAX7219_Display_Text(txt);
 Delay_ms(3000);
 MAX7219_Efface();

 Freq=0;
 while(Freq<999)
 {
 MAX7219_Affiche_Long(Freq); Delay_ms(50);
 Freq++;
 }




 }
 while(1);
}
